Subject: Re: PPC_OCP and ppc_sys problem while running kernel2.6 on ML403

From: "David H. Lynch Jr." <[email-masked]>
Date: Wed, 09 May 2007 02:46:35 -0400

[email-masked] wrote:
> Hi, all 
>     I met the CONFIG_PPC_OCP related problem while running  MontaVista linux based on kernel 2.6.17 on Xilinx ML403.I have been confused with some questions about CONFIG_PPC_OCP and ppc_sys.Any reply from anyone is appreciate.
>     From which version did the kernel.org tree stop using the OCP infrastructure and begin to use the ppc_sys infrastructure?Why did this change occur?what disadvantages dose the OCP infrastructure have?
>     The LSP generated by EDK is still using the OCP infrastructure,so when it overwrites the kernel,mistakes happen.Is there any BSP version using ppc_sys which can solve the OCP problem?
>     Also,the ppc_sys dosen't seem to support Virtex board well because I saw most patches supplied drop both ppc_ocp and ppc_sys.What disadventages dose ppc_sys have?Is patching the only method to solve this problem?
>     Are there any patches supporting 2.6.17?
>     Expect your reply,thanks!
    I am not sure about versions, but I think OCP has been dropped for
mainline Linux Kernel sources for about a year.
    Even the replacement will be somewhat obsoleted when the Xilinx
BSP's move from the arch/ppc tree to the arch/powerpc trees.
   
    There is a some significant divergence between the Xilinx EDK
approach to supporting Linux and what is in the mainline kernel source.
    Slowly mainline kernel support for various Xilinx devices is
maturing. If your product does not require much support for hardware
that is not yet in the mainline sources I would highly recommend using
the mainline Kernel source.

    Currently there is support for the Xilinx ML300 and ML403 (with
support for Xilinx PIC, and UartLite) in the distribution kernels.
    My source (following the distribution source closely) for Pico cards
is available on Pico's Web Site, www.picocomputing.com.
    Grant Likely seems to be the staging point for moving broader Xilinx
IP support into the mailine kernel source.
    Grant maintains a xilinx-dev git tree that is even closer to the
source trees from kernel.org that includes deeper support that is in the
pipeline.
    I beleive with the exception of the Xilinx TEMAC, the only EDK
component needed is an xparameters.h file for your particular hardware.

-- 
Dave Lynch 					  	    DLA Systems
Software Development:  				         Embedded Linux
717.627.3770 	       [email-masked] 	  http://www.dlasys.net
fax: 1.253.369.9244 			           Cell: 1.717.587.7774
Over 25 years' experience in platforms, languages, and technologies too numerous to list.

"Any intelligent fool can make things bigger and more complex... It takes a touch of genius - and a lot of courage to move in the opposite direction."
Albert Einstein